#include <iostream>
#include <iomanip>
#include <cmath>
#include "common.h"

using namespace std;
using namespace cmmn;

int main(){
	cout << "信頼性係数 p(%) = ";
	double p;
	cin >> p;
	if ((p < 50.0) || (100.0 <= p)){
		cout << "信頼性係数の値が不適切です。 50% 以上、100% 未満の値を設定して下さい。" << endl;
		return 0;
	}
	double pa = (100.0 - p)/100.0;		//	有意水準
	cout << "N = ";
	cin >> N;
	if (N < 1){
		cout << "N の値が不適切です。 N は 1 以上の値を設定します。" << endl;
		return 0;
	}
	cout << "k = ";
	cin >> k;
	if ((k < 0) || (k > N)){
		cout << "k の値が不適切です。 0 <= k <= N であるようにします。" << endl;
		return 0;
	}

	LogCombi = new double[N+1];	//	２項係数の対数値用配列
	for (int i = 0; i <= N; i++){
		if ((i == 0) || (i == N)) LogCombi[i] = 0.0;
		else {
			double v = 0.0;
			for (int j = i; j >= 1; j--)
				v += log(N + 1.0 - j) - log( j );
			LogCombi[i] = v;
		}
	}

	double LB, UB;
	if (UCum_prob(0.0) > (pa/2.0)){
		LB = 0.0; 
		Bisection( Cum_prob, -1.0, pa/2.0, 0.0, 1.0, UB, 1.0e-9 );
	}else{
		if (Cum_prob(1.0) > (pa/2.0)){
						UB = 1.0;
						Bisection( UCum_prob, 1.0, pa/2.0, 0.0, 1.0, LB, 1.0e-9 );
				 }else{
						Bisection( Cum_prob, -1.0, pa/2.0, 0.0, 1.0, UB, 1.0e-9 );
						Bisection( UCum_prob, 1.0, pa/2.0, 0.0, 1.0, LB, 1.0e-9 );
				 }
			 }
	cout << p << "% 信頼区間 = [" << setprecision(5) << LB << ", " << UB << "]" << endl;

	delete [] LogCombi;
	return 0;
}
