//#include "stdafx.h"
#include <cmath>
#include "common.h"

using namespace std;

namespace cmmn {

//	using namespace System;

	double p, pa;

	int N, k;

	double * LogCombi;



	//     Bisection法による根の計算    

	void Bisection( double (*f)(double),
					double s,					 //   fが増加関数のとき s > 0.0
					double c,					 //   根に対する関数値
					double L_b, double U_b,		 //   根の存在区間の下限と上限
					double & Root,				 //   根  f(Root) = c
					double acc ){
		if ( (f(L_b) - c) * (f(U_b) - c) > 0.0 ){
			throw  "上限と下限の組み合わせが不適切です。";
		}
		do {
			double m = 0.5 * (L_b + U_b);
			double v = f(m);
			if ( s * (v - c) > 0.0 ) {
				U_b = m;
			} else {
				L_b = m;
			}
		} while ( (abs(U_b - L_b) >= acc * abs(U_b))
					&&
				  ( (abs(U_b) + abs(L_b)) >= 1.0e-14)
				);
		Root = 0.5 * (L_b + U_b);
	}

	//
	//		２項分布
	//
	double prob_term( double p, int N, int i ){
		if (p <= 0.0){
				if (i >= 1) return 0.0;
				else		return 1.0;
		}else if (p >= 1.0){
				if (i == N) return 1.0;
				else		return 0.0;
		}else{
			return exp(LogCombi[i] + (i * log(p) + (N - i) * log(1.0 - p)));
		}
	}

	//
	//	Prob(X <= k)
	//
	double Cum_prob( double p ){
		double v = 0.0;
		for (int i = 0; i <= k; i++)
			v += prob_term( p, N, i );
		return v;
	}

	//
	//	Prob(X >= k)
	//
	double UCum_prob( double p ){
		double v = 0.0;
		for (int i = N; i >= k; i--)
			v += prob_term( p, N, i );
		return v;
	}


}
